#include "kernel.h"

void MMU_read(struct PageTableEntry *pt, size_t page_no)
{
	if (!pt[page_no].p)
		KERNEL_page_fault(pt, page_no);

	pt[page_no].r = 1;
}

void MMU_write(struct PageTableEntry *pt, size_t page_no)
{
	if (!pt[page_no].p)
		KERNEL_page_fault(pt, page_no);

	pt[page_no].r = 1;
	pt[page_no].m = 1;
}
